<template>
  <div>
    <BreadCrumb />
    <div class="relative flex lg:flex-row md:flex-col flex-col w-full h-full my-4 font-nunito text-sm">
      <div class="flex flex-col lg:flex-row md:flex-row rounded-md bg-white shadow p-4">
        <div class="lg:w-1/2 md:w-5/12 pr-2" v-if="selectedVariation">
          <div class="flex justify-center py-2 lg:max-w-0 md:max-w-sm" v-if="image">
              <img class="" :src="apiStorage + image.source" alt="product">
          </div>
          <div class="flex justify-center py-2 lg:max-w-0 md:max-w-sm" v-else>
            <img class="" src="https://via.placeholder.com/400" alt="">
          </div>
          <div class="flex flex-row my-2 h-full">
            <div v-for="(image, index) in selectedVariation.images" :key="index">
              <div class="mr-2 cursor-pointer" @click="updateImage(image)">
                <img class="rounded-lg w-16 h-16 hover:opacity-75 transition-all duration-500 ease" :src="apiStorage + image.source" :alt="image.alt" >
              </div>
            </div>
          </div>
        </div>

        <div class="lg:w-2/4 md:w-1/2 h-full">

          <h1 class="font-semibold text-xl">{{ product.name }}</h1>
          <div class="my-2"><StarRating class="w-20" :rating="rating" :star-style="ratingStyle" :isIndicatorActive="false" /></div>
          <div class="flex">
            <h2 class="font-semibold">SKU:&nbsp;</h2>
            <span v-if="selectedVariation" class="uppercase">{{ selectedVariation.sku }}</span>
          </div>
          <h2 class="font-light">{{ product.details }}</h2>

          <p v-if="product.description" class="font-light my-4 text-justify w-full">
              {{ product.description }}
          </p>

          <hr>

          <div class="my-4" v-if="!product.in_stock">
              <span class="rounded-lg bg-gray-300 py-2 px-3">Fora do Estoque</span>
          </div>
            <ProductOption
                v-for="attribute in product.attributes"
                :attribute="attribute"
                :key="attribute.id"
                v-model="form.variation"
                @variationSelected="setVariation"
                @images="setImages"
            />
      </div>
    </div>
    <div class="lg:w-3/6 rounded-md bg-white px-6 py-3 lg:ml-4 shadow lg:my-0 md:my-2 min-w-min">
      <div class="text-gray-800 text-3xl font-bold">
          {{ product.price }}
      </div>
      <div class="text-sm text-gray-800">em até 12x sem juros no <span class="font-semibold">cartão de crédito</span></div>
      <div v-if="selectedVariation">
        <div v-if="selectedVariation && selectedVariation.in_stock">
          <span class="flex justify-center w-full text-green-700 font-bold text-lg rounded-lg px-4 py-2 bg-gray-100">In Stock</span>
          <div class="text-sm mt-2 text-gray-800">Disponíveis:&nbsp;<span class="text-sm text-gray-800 font-semibold">{{ selectedVariation.stock_count }}</span></div>
        </div>
        <div v-else>
          <span class="flex justify-center w-full text-red-700 font-bold text-lg rounded-lg px-4 py-2 bg-gray-100">Out Stock</span>
        </div>
      </div>
      <div v-if="selectedVariation && selectedVariation.in_stock" class="py-4">
        <VueSelect
          :data="parseInt(selectedVariation.stock_count)"
          v-model="form.quantity"
        >
          <template slot="SelectLabel" class="text-sm">
            qtd
          </template>
        </VueSelect>
      </div>
      <div class="flex w-full mt-2 justify-center" v-if="product.in_stock">
        <div
          @click="add"
          class="flex flex-row cursor-pointer px-20 py-3 text-xl rounded-md text-white bg-indigo-700 hover:bg-indigo-500 transition-all duration-500 ease w-full"
          :class=" { 'disabled' : selectedVariation && !selectedVariation.in_stock }"
        >
            <div class="flex w-full align-middle items-center justify-center">
              <svg class="h-6 w-6 text-white font-light" fill="currentColor" viewBox="0 0 64 64">
                <path d="M60.55 23h-6.19L37.93 9.87C37.97 9.58 38 9.29 38 9c0-3.31-2.69-6-6-6C28.69 3 26 5.69 26 9c0 0.29 0.03 0.58 0.07 0.87L9.64 23H3.45C1.54 23 0 24.57 0 26.5S1.54 30 3.45 30h57.11C62.46 30 64 28.43 64 26.5S62.46 23 60.55 23zM16.04 23l11.95-9.55C29.05 14.41 30.46 15 32 15c1.55 0 2.95-0.59 4.01-1.55L47.96 23H16.04z"></path><path d="M7 60c0.23 1.58 1 4 5 4 0 0 37 0 40 0 4 0 4.77-2.41 5-4 1-7 4-28 4-28H3C3 32 6 53 7 60zM46 39.4C46 38.07 47.12 37 48.5 37s2.5 1.07 2.5 2.4v18.21C51 58.93 49.88 60 48.5 60S46 58.93 46 57.6V39.4zM35 39.4C35 38.07 36.12 37 37.5 37s2.5 1.07 2.5 2.4v18.21C40 58.93 38.88 60 37.5 60S35 58.93 35 57.6V39.4zM24 39.4C24 38.07 25.12 37 26.5 37s2.5 1.07 2.5 2.4v18.21C29 58.93 27.88 60 26.5 60S24 58.93 24 57.6V39.4zM13 39.4C13 38.07 14.12 37 15.5 37s2.5 1.07 2.5 2.4v18.21C18 58.93 16.88 60 15.5 60S13 58.93 13 57.6V39.4z"></path>
              </svg>
              <span class="px-2">comprar</span>
            </div>
        </div>
      </div>
      <div v-else>
        <span class="flex w-full justify-center text-red-700 bg-gray-300 my-4 rounded py-4 font-semibold text-lg">Produto indisponível</span>
      </div>
    </div>
  </div>
  </div>
</template>
<style>
    .image-default {
        width: 400px;
        height: 400px;
    }
</style>
<script>
import { mapActions } from 'vuex'
import ProductOption from '@/components/products/ProductOption'
import StarRating from '@/components/StarRating'
import VueSelect from '@/components/form/VueSelect'
import BreadCrumb from '@/components/app/BreadCrumb'

require('dotenv').config()

export default {
  auth: 'guest',

  components: {
      ProductOption,
      StarRating,
      VueSelect,
      BreadCrumb
  },
  data () {
    return {
        product: null,
        form: {
            variation: null,
            quantity: 1
        },
        apiStorage: process.env.API_URL + '/storage/imgs/products/',
        rating: Math.random() * 3 + 2,
        ratingStyle: {
          fullStarColor: '#ed8a19',
          emptyStarColor: '#ccc',
          starWidth: 20,
          starHeight: 20
        },
        attributesSelected: null,
        image: null
      }
  },

  watch: {
      'form.variation' () {
          this.form.quantity = 1
      },

      selectedVariation(value) {
        this.form.variation = value
        this.image = value.images.find(image => image.is_active === true)
      },

      attributesSelected(attributes) {
        let attributesSelecteds = []

        for(const[key, value] of Object.entries(attributes)) {
          attributesSelecteds = Object.assign({ ...attributesSelecteds }, { [key]: { product_id: this.product.id, ...value } })
        }

        this.$store.dispatch('product/searchVariants', attributesSelecteds)
      }
  },

  created() {
    this.form.variation = this.selectedVariation
  },

  computed: {
    selectedVariation() {
      return this.$store.state.product.variant
    },
    loggedIn() {
      return this.$store.state.auth.loggedIn
    }
  },

  async asyncData({ params, app, store }){
      let response = await app.$axios.$get(`/api/products/${params.slug}`)

      store.dispatch('product/setParent', response.data)
      return {
          product: response.data
      }
  },

  methods: {
      ...mapActions({
          store: 'cart/store'
      }),

      setVariation(variation) {
        this.attributesSelected = Object.assign({...this.attributesSelected}, { ...variation })
      },

      setImages(images){
        this.image = images.find(image => image.is_active === true)
        this.images = images
      },

      updateImage(image) {
        this.image = image
      },

      add () {
        // if (this.loggedIn) {
          if (this.form.variation.id && this.form.quantity) {

            this.store([{
                id: this.form.variation.id,
                quantity: this.form.quantity
            }])
          } else {
            return
          }

            this.form = {
                variation: '',
                quantity: 1
            }
        // } else {
        //   this.$router.push(this.localePath({ path: '/login' }))
        // }

      }
  }
}

</script>

<style scoped>
  .disabled {
    pointer-events: none;

    /* for "disabled" effect */
    opacity: 0.75;
    background: #CCC;
  }
</style>
